

# Enable Version Check ( will required Internet connectivity )

# Use DNS TXT to check latest version  available on gitHub
# - stable
# - beta

# Provide response to REST API request

TXT_RECORD = "zigate.pipiche.net"

import Domoticz

def checkPluginVersion( branch ):

    import dns.resolver

    try:
        zigateVersions = (dns.resolver.query( TXT_RECORD,"TXT").response.answer[0][-1].strings[0]).decode('utf8')
    except:
        Domoticz.Error("DNS error while checking Plugin and Firmware version")
        return ( 0, 0, 0)

    stable, beta , firmwareMajor, firmwareMinor = zigateVersions.split(";")
    label, stableVersion = stable.split("=")
    label, betaVersion = beta.split("=")
    label, firmwareMajorVersion = firmwareMajor.split("=")
    label, firmwareMinorVersion = firmwareMinor.split("=")

    Domoticz.Log("checkPluginVersion - Available Plugin Versions are, stable: %s , beta: %s" %(stableVersion, betaVersion))
    Domoticz.Log("checkPluginVersion - Available Firmware Version is, Major: %s , Minor: %s" %(firmwareMajorVersion, firmwareMinorVersion))

    if branch == 'stable':
        return ( stableVersion, firmwareMajorVersion, firmwareMinorVersion )
    elif branch == 'beta':
        return ( betaVersion, firmwareMajorVersion, firmwareMinorVersion )
    else:
        Domoticz.Error("checkPluginVersion - Unknown branch: %s" %branch)

def checkPluginUpdate( currentVersion, availVersion):

    if availVersion > currentVersion:
        Domoticz.Log("checkPluginVersion - Upgrade available: %s" %availVersion)
        return True
    return False


def checkFirmwareUpdate( currentMajorVersion, currentFirmwareVersion, availfirmMajor, availfirmMinor):

    if int(availfirmMinor,16) > int(currentFirmwareVersion,16):
        Domoticz.Log("checkFirmwareUpdate - Firmware update available")
        return True
    return False
